### AUXILIAR FUNCTIONS

##***********************************************************##


busca <- function (x, S) {
  which(S[,1] == x[1] & S[,2] == x[2])
}


##***********************************************************##


int.mult <- function(lista, todos = NULL) {
  
  if(is.null(todos)) {
    todos <- unlist(lista)
  }

  comunes <- todos

  for(i in 1:length(lista)) {
    comunes <- intersect(comunes, lista[[i]])
  }

  comunes
}



##***********************************************************##



n.menor <-
function (x, S1, S2) {
 
  length(which(S1 <= x[1] &  S2 <= x[2]))

}




##***********************************************************##




noceros <-
function (x, num = TRUE, k = 0) {
  
  nn <- length(which(x > k))
  
  if (num) {
    nn
    
  } else {
    if(nn > 0) { which(x > k) } else { NULL }
  }
}




##***********************************************************##




ranking <-
function(results) {

  M <- results$M

  D <- results$D

  prob <- results$prob

  ## Changing NA by 0
  M[is.na(M)] <- 0
  D[is.na(D)] <- 0
  prob[is.na(prob)] <- 0


  ## Ranking

#   ranking1 <- M*prob
# 
#   ranking2 <- sign(M)*prob
# 
#   ranking3 <- M*D
# 
#   ranking4 <- M*D*prob

  ranking5 <- sqrt(M*M + D*D)*sign(M)


  ## Ranking results
  #list(ranking1, ranking2, ranking3, ranking4, ranking5)
  theranking <- data.frame(rownames(results), ranking5)
  rownames(theranking) <- NULL
  colnames(theranking) <- c("ID", "statistic")
  
  theranking

}



##***********************************************************##



sim.samples <-
function(counts1, counts2 = NULL, pnr = 1, nss = 5, v = 0.02) {
  seqdep <- c(sum(counts1), sum(counts2))
  num.reads1 <- (pnr + c(-v,v))*seqdep[1]

  muestras <- vector("list")
  
  muestras$c1 <- NULL
  for (s in 1:nss) {
    tama <- round(runif(1, num.reads1[1], num.reads1[2]), 0)
    muestras$c1 <- cbind(muestras$c1,
                         rmultinom(1, size = tama, prob = counts1))
  }

  if(!is.null(counts2)) {
    num.reads2 <- (pnr + c(-v,v))*seqdep[2]
    muestras$c2 <- NULL
    for (s in 1:nss) {
      tama <- round(runif(1, num.reads2[1], num.reads2[2]), 0)
      muestras$c2 <- cbind(muestras$c2,
                           rmultinom(1, size = tama, prob = counts2))
    }
  }

  muestras
}





##***********************************************************##



sinceros <-
function (datos, k) {
  datos0 <- datos

  if (is.null(k)) {

    mini0 <- min(datos[noceros(datos, num = FALSE, k = 0)])

    kc <- mini0/2

    datos0[datos0 == 0] <- kc

  } else {

    datos0[datos0 == 0] <- k

  }
  
  datos0
}





##***********************************************************##



